Wireshark 2.9.0-477-g68ec514b The Wireshark network protocol analyzer

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
QCPFinancial Class Reference

A plottable representing a financial stock chart. More...

Inheritance diagram for QCPFinancial:

## Public Types
enum | ChartStyle { csOhlc, csCandlestick }

## Public Member Functions
| QCPFinancial (QCPAxis *keyAxis, QCPAxis *valueAxis)
QCPFinancialDataMap * | data () const
ChartStyle | chartStyle () const
double | width () const
bool | twoColored () const
QBrush | brushPositive () const
QBrush | brushNegative () const
QPen | penPositive () const
QPen | penNegative () const
void | setData (QCPFinancialDataMap *data, bool copy=false)
void | setData (const QVector< double > &key, const QVector< double > &open, const QVector< double > &high, const QVector< double > &low, const QVector< double > &close)
void | setChartStyle (ChartStyle style)
void | setWidth (double width)
void | setTwoColored (bool twoColored)
void | setBrushPositive (const QBrush &brush)
void | setBrushNegative (const QBrush &brush)
void | setPenPositive (const QPen &pen)
void | setPenNegative (const QPen &pen)
void | addData (const QCPFinancialDataMap &dataMap)
void | addData (const QCPFinancialData &data)
void | addData (double key, double open, double high, double low, double close)
void | addData (const QVector< double > &key, const QVector< double > &open, const QVector< double > &high, const QVector< double > &low, const QVector< double > &close)
void | removeDataBefore (double key)
void | removeDataAfter (double key)
void | removeData (double fromKey, double toKey)
void | removeData (double key)
virtual void | clearData ()
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Member Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
bool | antialiasedErrorBars () const
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
bool | selectable () const
bool | selected () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setAntialiasedErrorBars (bool enabled)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual bool | addToLegend ()
virtual bool | removeFromLegend () const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false) const
Public Member Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Static Public Member Functions
static QCPFinancialDataMap | timeSeriesToOhlc (const QVector< double > &time, const QVector< double > &value, double timeBinSize, double timeBinOffset=0)

## Protected Member Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual QCPRange | getKeyRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
void | drawOhlcPlot (QCPPainter *painter, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end)
void | drawCandlestickPlot (QCPPainter *painter, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end)
double | ohlcSelectTest (const QPointF &pos, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end) const
double | candlestickSelectTest (const QPointF &pos, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end) const
void | getVisibleDataBounds (QCPFinancialDataMap::const_iterator &lower, QCPFinancialDataMap::const_iterator &upper) const
Protected Member Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
QPen | mainPen () const
QBrush | mainBrush () const
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
void | applyErrorBarsAntialiasingHint (QCPPainter *painter) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
Protected Member Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Protected Attributes
QCPFinancialDataMap * | mData
ChartStyle | mChartStyle
double | mWidth
bool | mTwoColored
QBrush | mBrushPositive
QBrush | mBrushNegative
QPen | mPenPositive
QPen | mPenNegative
Protected Attributes inherited from QCPAbstractPlottable
QString | mName
bool | mAntialiasedFill
bool | mAntialiasedScatters
bool | mAntialiasedErrorBars
QPen | mPen
QPen | mSelectedPen
QBrush | mBrush
QBrush | mSelectedBrush
QPointer< QCPAxis > | mKeyAxis
QPointer< QCPAxis > | mValueAxis
bool | mSelectable
bool | mSelected
Protected Attributes inherited from QCPLayerable
bool | mVisible
QCustomPlot * | mParentPlot
QPointer< QCPLayerable > | mParentLayerable
QCPLayer * | mLayer
bool | mAntialiased

## Friends
class | QCustomPlot
class | QCPLegend

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)
Protected Types inherited from QCPAbstractPlottable
enum | SignDomain { sdNegative, sdBoth, sdPositive }

## Detailed Description

A plottable representing a financial stock chart.

This plottable represents time series data binned to certain intervals, mainly used for stock charts. The two common representations OHLC (Open-High-Low-Close) bars and Candlesticks can be set via setChartStyle.

The data is passed via setData as a set of open/high/low/close values at certain keys (typically times). This means the data must be already binned appropriately. If data is only available as a series of values (e.g. price against time), you can use the static convenience function timeSeriesToOhlc to generate binned OHLC-data which can then be passed to setData.

The width of the OHLC bars/candlesticks can be controlled with setWidth and is given in plot key coordinates. A typical choice is to set it to (or slightly less than) one bin interval width.

# Changing the appearance

Charts can be either single- or two-colored (setTwoColored). If set to be single-colored, lines are drawn with the plottable's pen (setPen) and fills with the brush (setBrush).

If set to two-colored, positive changes of the value during an interval (close >= open) are represented with a different pen and brush than negative changes (close < open). These can be configured with setPenPositive, setPenNegative, setBrushPositive, and setBrushNegative. In two-colored mode, the normal plottable pen/brush is ignored. Upon selection however, the normal selected pen/brush (setSelectedPen, setSelectedBrush) is used, irrespective of whether the chart is single- or two-colored.

## Member Enumeration Documentation

enum QCPFinancial::ChartStyle

Defines the possible representations of OHLC data in the plot.

See also
  setChartStyle

Enumerator
csOhlc | Open-High-Low-Close bar representation.
csCandlestick | Candlestick representation.

## Constructor & Destructor Documentation

QCPFinancial::QCPFinancial | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a financial chart which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The constructed QCPFinancial can be added to the plot with QCustomPlot::addPlottable, QCustomPlot then takes ownership of the financial chart.

## Member Function Documentation

void QCPFinancial::addData | ( | const QCPFinancialDataMap & | dataMap | ) |

Adds the provided data points in dataMap to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialDataMap.

See also
  removeData

void QCPFinancial::addData | ( | const QCPFinancialData & | data | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Adds the provided single data point in data to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialData.

See also
  removeData

void QCPFinancial::addData | ( | double | key,
|  | double | open,
|  | double | high,
|  | double | low,
|  | double | close
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Adds the provided single data point given by key, open, high, low, and close to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialData.

See also
  removeData

void QCPFinancial::addData | ( | const QVector< double > & | key,
|  | const QVector< double > & | open,
|  | const QVector< double > & | high,
|  | const QVector< double > & | low,
|  | const QVector< double > & | close
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Adds the provided open/high/low/close data to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialData.

See also
  removeData

void QCPFinancial::clearData | ( |  | ) |
| virtual

Removes all data points.

See also
  removeData, removeDataAfter, removeDataBefore

Implements QCPAbstractPlottable.

QCPFinancialDataMap * QCPFinancial::data | ( |  | ) | const
| inline

Returns a pointer to the internal data storage of type QCPFinancialDataMap. You may use it to directly manipulate the data, which may be more convenient and faster than using the regular setData or addData methods, in certain situations.

void QCPFinancial::removeData | ( | double | fromKey,
|  | double | toKey
| ) |  |

Removes all data points with keys between fromKey and toKey. if fromKey is greater or equal to toKey, the function does nothing. To remove a single data point with known key, use removeData(double key).

See also
  addData, clearData

void QCPFinancial::removeData | ( | double | key | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Removes a single data point at key. If the position is not known with absolute precision, consider using removeData(double fromKey, double toKey) with a small fuzziness interval around the suspected position, depeding on the precision with which the key is known.

See also
  addData, clearData

void QCPFinancial::removeDataAfter | ( | double | key | ) |

Removes all data points with keys greater than key.

See also
  addData, clearData

void QCPFinancial::removeDataBefore | ( | double | key | ) |

Removes all data points with keys smaller than key.

See also
  addData, clearData

double QCPFinancial::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the item is represented not by single lines but by an area like QCPItemRect or QCPItemText, a click inside the area returns a constant value greater zero (typically the selectionTolerance of the parent QCustomPlot multiplied by 0.99). If the click lies outside the area, this function returns -1.0.

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractPlottable.

void QCPFinancial::setBrushNegative | ( | const QBrush & | brush | ) |

If setTwoColored is set to true, this function controls the brush that is used to draw fills of data points with a negative trend (i.e. bars/candlesticks with close < open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setBrushPositive, setPenNegative, setPenPositive

void QCPFinancial::setBrushPositive | ( | const QBrush & | brush | ) |

If setTwoColored is set to true, this function controls the brush that is used to draw fills of data points with a positive trend (i.e. bars/candlesticks with close >= open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setBrushNegative, setPenPositive, setPenNegative

void QCPFinancial::setChartStyle | ( | QCPFinancial::ChartStyle | style | ) |

Sets which representation style shall be used to display the OHLC data.

void QCPFinancial::setData | ( | QCPFinancialDataMap * | data,
|  | bool | copy = `false`
| ) |  |

Replaces the current data with the provided data.

If copy is set to true, data points in data will only be copied. if false, the plottable takes ownership of the passed data and replaces the internal data pointer with it. This is significantly faster than copying for large datasets.

Alternatively, you can also access and modify the plottable's data via the data method, which returns a pointer to the internal QCPFinancialDataMap.

See also
  timeSeriesToOhlc

void QCPFinancial::setData | ( | const QVector< double > & | key,
|  | const QVector< double > & | open,
|  | const QVector< double > & | high,
|  | const QVector< double > & | low,
|  | const QVector< double > & | close
| ) |  |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Replaces the current data with the provided open/high/low/close data. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

See also
  timeSeriesToOhlc

void QCPFinancial::setPenNegative | ( | const QPen & | pen | ) |

If setTwoColored is set to true, this function controls the pen that is used to draw outlines of data points with a negative trend (i.e. bars/candlesticks with close < open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setPenPositive, setBrushNegative, setBrushPositive

void QCPFinancial::setPenPositive | ( | const QPen & | pen | ) |

If setTwoColored is set to true, this function controls the pen that is used to draw outlines of data points with a positive trend (i.e. bars/candlesticks with close >= open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setPenNegative, setBrushPositive, setBrushNegative

void QCPFinancial::setTwoColored | ( | bool | twoColored | ) |

Sets whether this chart shall contrast positive from negative trends per data point by using two separate colors to draw the respective bars/candlesticks.

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See also
  setPenPositive, setPenNegative, setBrushPositive, setBrushNegative

void QCPFinancial::setWidth | ( | double | width | ) |

Sets the width of the individual bars/candlesticks to width in plot key coordinates.

A typical choice is to set it to (or slightly less than) one bin interval width.

QCPFinancialDataMap QCPFinancial::timeSeriesToOhlc | ( | const QVector< double > & | time,
|  | const QVector< double > & | value,
|  | double | timeBinSize,
|  | double | timeBinOffset = `0`
| ) |  |
| static

A convenience function that converts time series data (value against time) to OHLC binned data points. The return value can then be passed on to setData.

The size of the bins can be controlled with timeBinSize in the same units as time is given. For example, if the unit of time is seconds and single OHLC/Candlesticks should span an hour each, set timeBinSize to 3600.

timeBinOffset allows to control precisely at what time coordinate a bin should start. The value passed as timeBinOffset doesn't need to be in the range encompassed by the time keys. It merely defines the mathematical offset/phase of the bins that will be used to process the data.

The documentation for this class was generated from the following files:

- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.h
- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.cpp